#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <unistd.h>
#include <string.h>
#include <netinet/tcp.h>
#include <mysql/mysql.h>

char		mysql_server[64];
char		*mysql_user = "opengts";
char		*mysql_password = "opengts";
char		*mysql_database = "gts";

int		ServerSocket;
unsigned int	CountClients;
int		MaxClients;

void addtodb(char *_vimei, double *_dvlat, double *_dvlong, char *_vspeed)
{
	MYSQL *mysql=mysql_init(NULL);
	if (!mysql_real_connect(mysql, mysql_server, mysql_user, mysql_password, mysql_database, 0, NULL, 0)) return;
	char buf[512];
	snprintf(buf, 512, "insert into EventData values((select accountID from Device where imeiNumber='%s'), (select deviceID from Device where imeiNumber='%s'), UNIX_TIMESTAMP(), 0, '%f', '%f', 0, '%s', 180, 0, '', 0, '', '', '', 0, 0, 0, '', UNIX_TIMESTAMP());", _vimei, _vimei, *_dvlat, *_dvlong, _vspeed);
	if (mysql_query(mysql, buf)) return;
	mysql_close(mysql);
	return;
};

void getcoord(const char *_buf, int _len, char *_vimei, double *_dvlat, double *_dvlong, char *_vspeed)
{
	char _vlat[32], _vlong[32];
	unsigned short i=5, p=5, n=0;
	long l;
	while(i<_len && _buf[i]!=';')
	{
		if (_buf[i]==',')
		{
			if (n==0) strncpy(_vimei, &_buf[p], i-p);
			else if (n==7)
			{
				strncpy(_vlat, &_buf[p], i-p);
				_vlat[4]=_vlat[3];
				_vlat[3]=_vlat[2];
				_vlat[2]='.';
				l=atol(&_vlat[3])*10;
				l/=6;
				sprintf(&_vlat[3], "%ld", l);
				*_dvlat=atof(_vlat);
			}
			else if (n==9)
			{
				strncpy(_vlong, &_buf[p], i-p);
				_vlong[5]=_vlong[4];
				_vlong[4]=_vlong[3];
				_vlong[3]='.';
				l=atol(&_vlong[4])*10;
				l/=6;
				sprintf(&_vlong[4], "%ld", l);
				*_dvlong=atof(_vlong);
			}
			else if (n==11)
			{
				strncpy(_vspeed, &_buf[p], i-p);
				n=0;
				while(_vspeed[n]!=0)
				{
					if (_vspeed[n]=='.')
					{
						_vspeed[n]=0;
						break;
					}
					n++;
				}
				break;
			}
			n++;
			p=i+1;
		}
		i++;
	}
};

void* callback(void *_p)
{
	CountClients++;
	int _socket=(int)_p;
	char buf[1024], vimei[64], vspeed[32];
	double vlat, vlong;
	int len;
	while ((len=recv(_socket, buf, 1024, 0))>0)
	{
		if (len<4) continue;
		if (buf[0]=='#' && buf[1]=='#')
		{
			send(_socket, "LOAD", 4, 0);
		}
		else if (buf[0]=='i' && buf[1]=='m' && buf[2]=='e' && buf[3]=='i')
		{
			vimei[0]=0;
			vlat=0;
			vlong=0;
			vspeed[0]=0;
			getcoord(buf, len, vimei, &vlat, &vlong, vspeed);
			if (vimei[0]!=0 && vspeed[0]!=0) addtodb(vimei, &vlat, &vlong, vspeed);
		}
	}
	CountClients--;
	return NULL;
};

int main()
{
	{
		pid_t pid, sid;
		pid = fork();
		if (pid < 0) return 1;
		if (pid > 0) return 0;

		sid = setsid();
		if (sid < 0) return 1;

		FILE *f=fopen("/var/run/tk103-gprs.pid", "w");
		if (f==0) return 1;
		char buf[32];
		snprintf(buf, 31, "%d", sid);
		fwrite(buf, strlen(buf), 1, f);
		fclose(f);

		f=fopen("/etc/opengts-tk103/gprs.conf", "r");
		if (f==0) return 1;
		fscanf(f, "mysql_server %63s", mysql_server);
		fclose(f);
	}

	ServerSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if ( ServerSocket == -1 )
	{
		return 1;
	}

	int optval=1;
	socklen_t optlen=sizeof(optval);

	if (setsockopt(ServerSocket, SOL_SOCKET, SO_KEEPALIVE, &optval, optlen) < 0)
	{
		close(ServerSocket);
		return 2;
	}

	int keepidle=3;
	setsockopt(ServerSocket, SOL_TCP, TCP_KEEPCNT, (void*)&keepidle, optlen);
	keepidle=40;
	setsockopt(ServerSocket, SOL_TCP, TCP_KEEPIDLE, (void*)&keepidle, optlen);
	keepidle=10;
	setsockopt(ServerSocket, SOL_TCP, TCP_KEEPINTVL, (void*)&keepidle, optlen);

	struct sockaddr_in addr_server;
	addr_server.sin_family=AF_INET;
	addr_server.sin_addr.s_addr=inet_addr("0.0.0.0");
	addr_server.sin_port=htons(5001);
	if ( bind(ServerSocket, (const struct sockaddr*)&addr_server, sizeof(addr_server)) == -1 )
	{
		return 3;
	}
	if ( listen(ServerSocket, 32) == -1 )
	{
		return 4;
	}
	CountClients=0;
	MaxClients=32;

	int ClientSocket;
	struct sockaddr_in addr_client;
	int addr_len=sizeof(addr_client);
	for(;;)
	{
		ClientSocket=accept(ServerSocket, (struct sockaddr*)&addr_client, (socklen_t*)&addr_len);
		if (ClientSocket>=0)
		{
			if (CountClients>=MaxClients)
			{
				shutdown(ClientSocket, SHUT_RDWR);
				close(ClientSocket);
				continue;
			}
			pthread_t pid;
			pthread_create(&pid, NULL, &callback, (void*)ClientSocket);
		}
		else break;
	};
	close(ServerSocket);

	return 0;
};
